/**
 ** RegPartida.java
 **
 ** Copyright (C) 1992, 1999, 2007, 2011 Mariano Alvarez Fernandez
 ** [e-mail: malfer at telefonica.net]
 **
 ** This file is part of the Parchis4A program.
 **
 ** Parchis4A is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** Parchis4A is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with Parchis4A.  If not, see <http://www.gnu.org/licenses/>.
 **
 **/

package com.fgrim.parchis4a;

public class RegPartida {

	public DefPartida dp;
	public int numpartidas;
	public int est[][];
	public boolean expandir;
	
	public RegPartida() {
		dp = new DefPartida();
		numpartidas = 0;
		est = new int[4][4];
		expandir = false;
	}
	
	public void acumula(EstadoPartida ep) {
		numpartidas++;
		for (int c=0; c<4; c++) {
			int pos = ep.jgha_terminado[c];
			if (pos >= 0) {
				est[c][pos]++;
			}
		}
	}
	
	public void set(EstadoPartida ep) {
		dp.set(ep);
		numpartidas = 0;
		acumula(ep);
	}
	
	int[] toArray() {
		int a[] = dp.toArray();
		int b[] = new int[11+17];
		b[11] = numpartidas;
		int ind = 12;
		for (int c=0; c<4; c++) {
			for (int j=0; j<4; j++) {
				b[ind++] = est[c][j];
			}
		}
		System.arraycopy(a, 0, b, 0, 11);
		return b;
	}

	public void set(int a[]) {
		dp.set(a);
		numpartidas = a[11];
		int ind = 12;
		for (int c=0; c<4; c++) {
			for (int j=0; j<4; j++) {
				est[c][j] = a[ind++];
			}
		}
	}

/*	public String toString() {
		String s;
		s = dp.toString();
		s += "\nNp: " + numpartidas;
		for (int c=0; c<4; c++) {
			s += "\n" + est[c][0] + " " + est[c][1] + " " + est[c][2] + " " + est[c][3];
		}
		s += "\n";
		return s;
	}*/

	public String toString() {
		String s;
		s = "TP: ";
		for (int c=0; c<4; c++) {
			if (dp.tipo_jugador[c] == DefPartida.NOJUEGA)
				s += "NJ ";
			else if (dp.tipo_jugador[c] == DefPartida.PERSONA)
				s += "P- ";
			else
				s += "R" + dp.nivel_maquina[c] + " ";
		}
		s += " Np: " + numpartidas + "\n";
		for (int c=0; c<4; c++) {
			if (dp.tipo_jugador[c] == DefPartida.NOJUEGA)
				continue;
			else if (dp.tipo_jugador[c] == DefPartida.PERSONA)
				s += "P-: ";
			else
				s += "R" + dp.nivel_maquina[c] + ": ";
			for (int j=0; j<dp.num_jg; j++) {
				s += (j+1) + "º ";
				s += ((est[c][j] * 100) / numpartidas) + "% ";
			}
			s += "\n";
		}
		s += "\n";
		return s;
	}

	public String cabecera() {
		String s;
		s = "TP: ";
		for (int c=0; c<4; c++) {
			if (dp.tipo_jugador[c] == DefPartida.NOJUEGA)
				s += "NJ ";
			else if (dp.tipo_jugador[c] == DefPartida.PERSONA)
				s += "P- ";
			else
				s += "R" + dp.nivel_maquina[c] + " ";
		}
		s += " Np: " + numpartidas;
		return s;
	}

	public String cuerpo() {
		String s;
		s = "";
		for (int c=0; c<4; c++) {
			if (dp.tipo_jugador[c] == DefPartida.NOJUEGA)
				continue;
			else if (dp.tipo_jugador[c] == DefPartida.PERSONA)
				s += "P-: ";
			else
				s += "R" + dp.nivel_maquina[c] + ": ";
			for (int j=0; j<dp.num_jg; j++) {
				s += (j+1) + "º ";
				s += ((est[c][j] * 100) / numpartidas) + "% ";
			}
			s += "\n";
		}
		return s;
	}

	public String ranking(int c) {
		String s = " |";
		for (int j=0; j<dp.num_jg; j++) {
		    s += String.format("%dº%3d%%|", j+1, (est[c][j] * 100) / numpartidas);
		}
		return s;
	}
}
